/* dict.h --    writedict  readdict */
#include "dict.h"

struct dict_elem *
readdict (const char *indictname,
	  struct dict_elem *inlist,
	  int maxlength)
{
  int i;
  FILE *inf;

  /*    */
  if ((inf = fopen (indictname, "r")) == NULL)
    return NULL;
  /*   dict_elem   */
  for (i = 0; i < maxlength - 1; i++)
    if (fread ((void *) &inlist[i], sizeof (struct dict_elem),
	       1, inf) < 1)
        break;
  fclose (inf);
  /*    */
  inlist[i].d_length = 0;
  /*    */
  return inlist;
}

int 
writedict (const char *dictname, struct dict_elem *elist)
{
  int j;
  FILE *outf;

  /*    */
  if ((outf = fopen (dictname, "w")) == NULL)
    return ERROR;
  /*    */
  for (j = 0; elist[j].d_length != 0; j++)
    ;
  /*    dict_elem */
  if (fwrite ((void *) elist, sizeof (struct dict_elem), j, outf) < j)
    {
      fclose (outf);
      return ERROR;
    }
  fclose (outf);
  return SUCCESS;
}

void 
main ()
{
  struct dict_elem delem1[2] =
  {
    {
      {'d', 'n', 'a', 'm', 'e', '\0'}, 2, 15, 3},
    {
      {'\0'}, 0, 0, 0}
  };
  struct dict_elem delem2[2];

  writedict ("dictionary", &delem1[0]);
  if (readdict ("dictionary", &delem2[0], 2))
    printf ("delem2: d_name = %s, d_start = %d, d_length = %d, d_type = %d\n",
	    delem2[0].d_name, delem2[0].d_start, delem2[0].d_length, delem2[0].d_type);
}
