#include <stdio.h>
#include <sys/mman.h>
#include <fcntl.h>

main (int argc, char **argv)
{
  int input, output;
  size_t filesize;
  void *source, *target;
  char endchar = '\0';

  /*     */
  if (argc != 3)
    {
      fprintf (stderr, ": copyfile  \n");
      exit (1);
    }

  /*      */
  if ((input = open (argv[1], O_RDONLY)) == -1)
    {
      fprintf (stderr, "    %s\n", argv[1]);
      exit (1);
    }

  if ((output = open (argv[2], O_RDWR | O_CREAT | O_TRUNC, 0666)) == -1)
    {
      close (input);
      fprintf (stderr, "    %s\n", argv[2]);
      exit (2);
    }

  /*       ,   . */
  filesize = lseek (input, 0, SEEK_END);
  lseek (output, filesize - 1, SEEK_SET);
  write (output, &endchar, 1);

  /*       . */
  if ((source = mmap (0, filesize, PROT_READ, MAP_SHARED, input,
		      0)) == (void *) -1)
    {
      fprintf (stderr, "   1  \n");
      exit (1);
    }

  if ((target = mmap (0, filesize, PROT_WRITE, MAP_SHARED, output,
		      0)) == (void *) -1)
    {
      fprintf (stderr, "   1   \n");
      exit (2);
    }

  /*  */
#if defined(__linux__)
/*  Linux memcpy()      */
  {
    int i;
    for (i = 0; i < filesize; i++)
      *((char *) target + i) = *((char *) source + i);
  }
#else
  memcpy (target, source, filesize);
#endif

  /*     */
  munmap (source, filesize);
  munmap (target, filesize);
  /*    */
  close (input);
  close (output);
  exit (0);
}
