   /*  copyfile   name1   name2 */

#include <unistd.h>
#include <fcntl.h>

#define BUFSIZE 512		/*    */
#define PERM 0644		/*      */

/*   name1   name2 */
int
copyfile (const char *name1, const char *name2)
{
  int infile, outfile;
  ssize_t nread;
  char buffer[BUFSIZE];

  if ((infile = open (name1, O_RDONLY)) == -1)
    return (-1);

  if ((outfile = open (name2, O_WRONLY | O_CREAT | O_TRUNC, PERM)) == -1)
    {
      close (infile);
      return (-2);
    }

  /*    name1  BUFSIZE  */
  while ((nread = read (infile, buffer, BUFSIZE)) > 0)
    {
      /*  buffer   . */
      if (write (outfile, buffer, nread) < nread)
	{
	  close (infile);
	  close (outfile);
	  return (-3);		/*   */
	}
    }

  close (infile);
  close (outfile);

  if (nread == -1)
    return (-4);		/*     */
  else				/*   */
    return (0);
}

/*  main    copyfile */
main ()
{
  copyfile ("test.in", "test.out");
}
