/*  proc_file --     */
/* ,    "data"   20  */
#include <unistd.h>
#include <fcntl.h>

int
fatal (char *s)
{
  perror (s);
  exit (1);
}

main ()
{
  int fd;
  pid_t pid;			/*   */
  char buf[10];			/*     */

  if ((fd = open ("data", O_RDONLY)) == -1)
    fatal ("  open ");

  read (fd, buf, 10);		/*     */
  printpos ("  fork", fd);
  /*    */

  switch (pid = fork ())
    {
    case 1:			/*  */
      fatal ("  fork ");
      break;
    case 0:			/*  */
      printpos ("   ", fd),
	read (fd, buf, 10);
      printpos ("   ", fd);
      break;
    default:			/*  */
      wait ((int *) 0);
      printpos ("   ", fd);
    }
}

       /*     */
int
printpos (const char *string, int filedes)
{
  off_t pos;

  if ((pos = lseek (filedes, 0, SEEK_CUR)) == -1)
    fatal ("  lseek");
  printf ("%s:%ld\n", string, pos);
}
