/*  sendmessage --    FIFO */
#include <fcntl.h>
#include <stdio.h>
#include <errno.h>

#define MSGSIZ 63

char *fifo = "fifo";

int 
fatal (char *s)
{
  perror (s);
  exit (1);
}

main (int argc, char **argv)
{
  int fd, j, nwrite;
  char msgbuf[MSGSIZ + 1];

  if (argc < 2)
    {
      fprintf (stderr, ": sendmessage  \n");
      exit (1);
    }
  /*   fifo,   O_NONBLOCK */
  if ((fd = open (fifo, O_WRONLY | O_NONBLOCK)) < 0)
    fatal ("  open  fifo");
  /*   */
  for (j = 1; j < argc; j++)
    {
      if (strlen (argv[j]) > MSGSIZ)
	{
	  fprintf (stderr, "   %s\n", argv[j]);
	  continue;
	}
      strcpy (msgbuf, argv[j]);
      if ((nwrite = write (fd, msgbuf, MSGSIZ + 1)) == -1)
	{
	  fatal ("  ");
	}
    }
  exit (0);
}
