/*    O_NONBLOCK */
#include <fcntl.h>
#include <errno.h>

#define MSGSIZE 6
int parent (int *);
int child (int *);

char *msg1 = "hello";
char *msg2 = "bye!!";

int 
fatal (char *s)
{
  perror (s);
  exit (1);
}

main ()
{
  int pfd[2];

  /*   */
  if (pipe (pfd) == -1)
    fatal ("  pipe ");
  /*   O_NONBLOCK   p[0] */
  if (fcntl (pfd[0], F_SETFL, O_NONBLOCK) == -1)
    fatal ("  fcntl");
  switch (fork ())
    {
      case
    -1:			/*  */
      fatal ("  fork");
    case 0:			/*   */
      child (pfd);
    default:			/*   */
      parent (pfd);
    }
}

int 
parent (int p[2])		/*    */
{
  int nread;
  char buf[MSGSIZE];

  close (p[1]);
  for (;;)
    {
      switch (nread = read (p[0], buf, MSGSIZE))
	{
	case -1:
	  /* ,     . */
	  if (errno == EAGAIN)
	    {
	      printf ("( )\n");
	      sleep (1);
	      break;
	    }
	  else
	    fatal ("  read");
	case 0:
	  /*   . */
	  printf (" \n");
	  exit (0);
	default:
	  printf ("MSG=%s\n", buf);
	}
    }
}

int 
child (int p[2])
{
  int count;

  close (p[0]);
  for (count = 0; count < 3; count++)
    {
      write (p[1], msg1, MSGSIZE);
      sleep (3);
    }
  /*    */
  write (p[1], msg2, MSGSIZE);
  exit (0);
}
