/*  deadlock --   */
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>

int 
fatal (char *s)
{
  perror (s);
  exit (1);
}

main ()
{
  int fd;
  struct flock first_lock;
  struct flock second_lock;

  first_lock.l_type = F_WRLCK;
  first_lock.l_whence = SEEK_SET;
  first_lock.l_start = 0;
  first_lock.l_len = 10;
  second_lock.l_type = F_WRLCK;
  second_lock.l_whence = SEEK_SET;
  second_lock.l_start = 10;
  second_lock.l_len = 5;

  fd = open ("locktest", O_RDWR);

  if (fcntl (fd, F_SETLKW, &first_lock) == -1)	/*A */
    fatal ("A");

  printf ("A:   ( %d)\n", getpid ());

  switch (fork ())
    {
    case -1:
      /*  */
      fatal ("  fork");
    case 0:
      /*   */
      if (fcntl (fd, F_SETLKW, &second_lock) == -1)	/*B */
	fatal ("B");
      printf ("B:   ( %d)\n", getpid ());
      if (fcntl (fd, F_SETLKW, &first_lock) == -1)	/*C */
	fatal ("C");
      printf ("C:   ( %d)\n", getpid ());
      exit (0);
    default:
      /*   */
      printf ("  \n");
      sleep (10);
      if (fcntl (fd, F_SETLKW, &second_lock) == -1)	/*D */
	fatal ("D");
      printf ("D:   ( %d)\n", getpid ());
    }
}
