/*  testsem --      */
#include "pv.h"


/*  initsem --   */
int 
initsem (key_t semkey)
{
  int status = 0, semid;
  if ((semid = semget (semkey, 1,
		       SEMPERM | IPC_CREAT | IPC_EXCL)) == -1)
    {
      if (errno = EEXIST)
	semid = semget (semkey, 1, 0);
    }
  else
    /*    ... */
    {
#if !defined(__linux__)
      semun arg;
#else
      union semun arg;
#endif
      arg.val = 1;
      status = semctl (semid, 0, SETVAL, arg);
    }
  if (semid == -1 || status == -1)
    {
      perror ("  initsem");
      return (-1);
    }
  /*    */
  return (semid);
}

/*  p.c --  p   */
int 
p (int semid)
{
  struct sembuf p_buf;
  p_buf.sem_num = 0;
  p_buf.sem_op = -1;
  p_buf.sem_flg = SEM_UNDO;
  if (semop (semid, &p_buf, 1) == -1)
    {
      perror ("  p(semid)");
      exit (1);
    }
  return (0);
}

/*  v.c --  v   */
int 
v (int semid)
{
  struct sembuf v_buf;
  v_buf.sem_num = 0;
  v_buf.sem_op = 1;
  v_buf.sem_flg = SEM_UNDO;
  if (semop (semid, &v_buf, 1) == 1)
    {
      perror ("  v(semid)");
      exit (1);
    }
  return (0);
}

void handlesem (key_t skey);

main ()
{
  key_t semkey = 0x200;
  int i;
  for (i = 0; i < 3; i++)
    {
      if (fork () == 0)
	handlesem (semkey);
    }
}
void 
handlesem (key_t skey)
{
  int semid;
  pid_t pid = getpid ();

  if ((semid = initsem (skey)) < 0)
    exit (1);

  printf ("\n %d   \n", pid);
  p (semid);
  printf (" %d   \n", pid);

  /*        */
  sleep (10);

  printf (" %d   \n", pid);
  v (semid);
  printf (" %d  \n", pid);

  exit (0);
}
