/*  unfreeze --   */
#include <unistd.h>
#include <stdio.h>
#include <signal.h>
#include <sys/types.h>

#define LINESZ 50
#define SUCCESS 0
#define ERROR (-1)

/*  ,     */
int 
dokill (pid_t procid, const char *line, const char *hd)
{
  char c;

  printf ("\n ,    :\n");
  printf ("\t%s\t%s\n", hd, line);
  printf (" 'y'    %d\n", procid);
  printf ("\nYes\\No? > ");
  /*      */
  scanf ("%1s", &c);
  if (c == 'y' || c == 'Y')
    {
      kill (procid, SIGKILL);
      return (SUCCESS);
    }
  return (ERROR);
}

main (int argc, char **argv)
{
  /*        */
  static char *pspart = "ps t ";
  static char *fmt = "%d %*s %*s %*s %s";
  char comline[LINESZ], inbuf[LINESZ], header[LINESZ];
  char name[LINESZ];
  FILE *f;
  int killflag = 0, j;
  pid_t pid;

  if (argc <= 2)
    {
      fprintf (stderr, ": %s   ...\n",
	       argv[0]);
      exit (1);
    }

  /*    */
  strcpy (comline, pspart);
  strcat (comline, argv[1]);

  /*   ps */
  if ((f = popen (comline, "r")) == NULL)
    {
      fprintf (stderr, "%s:    ps \n",
	       argv[0]);
      exit (2);
    }

  /*     ps    */
  if (fgets (header, LINESZ, f) == NULL)
    {
      fprintf (stderr, "%s:    ps?\n", argv[0]);
      exit (3);
    }

  /*  ,    */
  while (fgets (inbuf, LINESZ, f) != NULL)
    {
      if (sscanf (inbuf, fmt, &pid, name) < 2)
	break;
      for (j = 2; j < argc; j++)
	{
	  if (strcmp (name, argv[j]) == 0)
	    {
	      if (dokill (pid, inbuf, header) == SUCCESS)
		killflag++;
	    }
	}
    }
  /*  ,    */
  if (!killflag)
    fprintf (stderr, "%s:     %s\n",
	     argv[0], argv[1]);
  exit (0);
}
